<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class template extends clsmain
{
private $template_path;
private $dir;
private $pathindex;
function __construct($path,$index)
{
        parent::__construct();
        $this->template_path=$_SERVER['DOCUMENT_ROOT'].DOCROOT.'gb/'.$path;
        $this->dir=(isset($_GET['dir'])? $_GET['dir'] : $this->template_path);
        if(strpos($this->dir,$this->template_path)!==0){$this->dir=$this->template_path;}
		$this->pathindex=$index;
}
private function set_clipboard()
{
        $source=fw_strip_slashes(rawurldecode($_GET['source']));
		if(!setcookie('fw_clipboard',$source)){fw_message(true,'Fail to copy');}
		else{echo '<script>parent.document.getElementById("clipboard").innerHTML=\'<a title="'.$source.'" href="#" onclick="javascript:fwPast()"><img src="images/past.gif" /></a>\';</script>';}
		exit;
}
private function extract()
{
        $filename=fw_strip_slashes(rawurldecode($_GET['source']));
		if(strpos($filename,$this->template_path)!==0){exit;}
		if(!file_exists($filename)){fw_message(true,'Source not found!');}
		else{
			$dir=substr($filename,0,strrpos($filename,'/')+1);
			$zip = new ZipArchive;
			if($zip->open($filename) === TRUE){
				$zip->extractTo($dir);
				$zip->close();
				echo '<script>parent.location.reload(true);</script>';}
			else{fw_message(true,'Sorry! Unable to extract file.');}
		}
		exit;
}
private function show_uploadlist($message='')
{
        $clipboard=(isset($_COOKIE['fw_clipboard'])? $_COOKIE['fw_clipboard']:'');
		if(!empty($clipboard)){if(strpos($clipboard,$this->template_path)!==0){$clipboard='';}}
		if(empty($clipboard)){$cliplink='<img src="images/pastempty.gif" />';}
		else{$cliplink='<a title="'.$clipboard.'" href="#" onclick="javascript:fwPast()"><img src="images/past.gif" /></a>';}
		$caption=substr($this->template_path,1,-1);
		$script='<script type="text/javascript" src="script/template.js"></script><script type="text/javascript">var pathindex='.$this->pathindex.';var cDir="'.addslashes($this->dir).'";</script>';
        $this->build_head($caption,$script,'');
        echo '<div id="feedback" style="margin:0;padding:0;">'.$message.'</div>';
		echo '<iframe name="formSubmit" id="formSubmit" style="display:none;"></iframe>';
		echo '<table id="list">';
		echo '<tr><td colspan="3" style="background:#e0e0e0;padding:8px 5px;border-bottom:1px solid #c0c0c0;"><div style="float:left;clear:left;"><a href="index.php?qur='.$this->pathindex.'M">'.$caption.'</a> / ';
        if($this->dir!==$this->template_path){
                $path_array=explode('/',substr($this->dir,strlen($this->template_path),-1));
                $links=$this->template_path;
                for($i=0; $i<count($path_array); $i++){
                       $links.=$path_array[$i].'/';
                       echo (($i==count($path_array)-1)? $path_array[$i] : '<a href="index.php?qur='.$this->pathindex.'M&dir='.$links.'">'.$path_array[$i].'</a>/');}}
        echo '</div><div id="clipboard">'.$cliplink.'</div></td></tr>';
		echo '<tr><td colspan="3"><img title="Create new folder" src="images/new_folder.gif" /><a href="javascript:fwNewFolder()">Create new folder:</a></td></tr>';
        $dirs='';
		$files='';
		if($handle=opendir($this->dir)){
			while (false !== ($item = readdir($handle))){if($item != "." && $item != ".."){
				if(is_dir($this->dir.$item)){
					$arg="'".fw_php2javascript(($this->dir).$item.'/')."'";
					$dirs.='<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'"><td><img src="images/folder.gif"/><a href="index.php?qur='.$this->pathindex.'M&dir='.$this->dir.$item.'/">'.$item.'</a></td><td>-</td><td style="text-align:center">';
					$dirs.='<a style="color:#f8850f;" href="#" onclick="return fwDownload('.$arg.');">Download</a> | ';
					$dirs.='<a style="color:#335599;" href="#" onclick="return fwCopy('.$arg.');">Copy</a> | ';
					$dirs.='<a style="color:#339955;" href="#" onclick="return fwRename('.$arg.');">Rename</a> | ';
					$dirs.='<a style="color:#993322;" href="#" onclick="return fwDelete('.$arg.');">Delete</a></td></tr>';
				}
				else{
					$filename=$this->dir.$item;
					$arg="'".fw_php2javascript($filename)."'";
					$extension=substr($item,strrpos($item,'.')+1);
					$img='images/file_inactive.gif';
					$open_url='';
//If imagefile.
					if(getimagesize($filename)!==false){
						$open_url='javascript:fwOpenImage(\''.urlencode(fw_abs_to_url($filename)).'\')';
						$img='images/file_browser.gif';}
//If editable file.
					if(array_search($extension,array('php','html','htm','txt','css','js','htaccess'))!==false){
						$open_url='javascript:fwOpenEdit(\''.urlencode($filename).'\')';
						$img='images/file_active.gif';}
					if($extension=='zip'){
						$img='images/zip.gif';
						$onclick=' onclick="return fwExtract('.$arg.')"';
						$open_url='#';
					}
					$files.='<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'"><td><img src="'.$img.'"/>'.(($open_url=='')? $item : '<a href="'.$open_url.'"'.(isset($onclick)? $onclick:'').'>'.$item.'</a>').'</td><td>'.round(filesize($filename)/1024,1).'KB </td><td style="text-align:center;">';
					$files.='<a style="color:#f8850f;" href="#" onclick="return fwDownload('.$arg.');">Download</a> | ';
					$files.='<a style="color:#335599;" href="#" onclick="return fwCopy('.$arg.');">Copy</a> | ';
					$files.='<a style="color:#339955;" href="#" onclick="return fwRename('.$arg.');">Rename</a> | ';
					$files.='<a style="color:#993322;" href="#" onclick="return fwDelete('.$arg.');">Delete</a></td></tr>';
				}
			}}
			closedir($handle);
		}
		echo $dirs.$files;
        echo '<tr><td colspan="3" style="background:#e0e0e0;text-align:right;">';
        echo '<form name="frmUpload" enctype="multipart/form-data" target="formSubmit" action="index.php?qur='.$this->pathindex.'M1&dir='.urlencode($this->dir).'" method="POST" style="float:right; margin:0; color:#000000;" onSubmit="return fwCheckSubmit(this);">';
        echo '<input type="hidden" name="MAX_FILE_SIZE" value="200000" />';
        echo 'Choose a file to upload: <input name="file" type="file" style="padding-left:5px; width:180px; font-size:11px; color:#666666;"/>&nbsp;&nbsp;<input name="submit" type="submit" value="Upload File" style="width:80px; font-size:11px; color:#333333;"/>&nbsp;<input type="reset" value="Reset" style="width:80px; font-size:11px; color:#333333;"></form>';
        echo '</td></tr>';
        echo '</table></div>';
        $this->build_footer();
}
private function delete_file()
{
        $filename=fw_strip_slashes(rawurldecode($_GET['source']));
		if(strpos($filename,$this->template_path)!==0){exit;}
        $x=(substr($filename,-1)=='/');
		if($x){$filename=substr($filename,0,-1);}
		if(!file_exists($filename)){fw_message(true,'Source not found!');}
		else{
			if($x){
				if($this->rec_delete_folder($filename)){echo '<script>parent.location.reload(true);</script>';}
				else{fw_message(true,'Sorry! Unable to delete directory. Please check file permission.');}
				}
			else{
				if(@unlink($filename)){echo '<script>parent.location.reload(true);</script>';}
				else{fw_message(true,'Sorry! Unable to delete file. Please check file permission.');}
				}
		}
        exit;
}

private function rec_delete_folder($folderPath )
{
        if(is_dir($folderPath)){
                 foreach(scandir($folderPath) as $value){
                       if($value != "." && $value != ".." ){
                                 $value = $folderPath . "/" . $value;
                                 if(is_dir($value)){$this->rec_delete_folder($value);}
                                 elseif(is_file($value)){@unlink ( $value );}
                       }
                 }
                 return rmdir ( $folderPath );
        }
        else{return false;}
}
private function compress()
{
        foreach(glob('backup/*.zip') as $f){@unlink($f);}
        $filename=fw_strip_slashes(rawurldecode($_GET['source']));
		if(strpos($filename,$this->template_path)!==0){exit;}
        $x=(substr($filename,-1)=='/');
		if($x){$filename=substr($filename,0,-1);}
		if(!file_exists($filename)){fw_message(true,'Source not found!');}
		$path=substr($filename,0,strrpos($filename,'/')+1);
		$name=substr($filename,strlen($path));
        $zipfile=rand(1000,9999).'.zip';
        $zip = new ZipArchive;
        $res = $zip->open('backup/'.$zipfile, ZipArchive::CREATE);
        if($res !== TRUE){
                fw_message(true,'Error: Unable to create zip file');
                exit;}
        if(!$x){$zip->addFile($filename,$name);}
        else{$this->recurse_zip($filename,$zip,$path);}
        $zip->close();
		$name.='.zip';
		@header("Content-type: application/zip");
		@header("Content-Disposition: attachment; filename=$name");
		echo @file_get_contents('backup/'.$zipfile);
		@unlink('backup/'.$zipfile);
        exit;
}
private function recurse_zip($src,&$zip,$path) {
        $dir = opendir($src);
        while(false !== ( $file = readdir($dir)) ) {
            if (( $file != '.' ) && ( $file != '..' )) {
                if ( is_dir($src . '/' . $file) ) {
                    $this->recurse_zip($src . '/' . $file,$zip,$path);
                }
                else {
                    $zip->addFile($src . '/' . $file,substr($src . '/' . $file,strlen($path)));
                }
            }
        }
        closedir($dir);
}
private function recurse_copy($src,$dst) {
        $dir = opendir($src);
        @mkdir($dst);
        while(false !== ( $file = readdir($dir)) ) {
            if (( $file != '.' ) && ( $file != '..' )) {
                if ( is_dir($src . '/' . $file) ) {
                    $this->recurse_copy($src . '/' . $file,$dst . '/' . $file);
                }
                else {
                    copy($src . '/' . $file,$dst . '/' . $file);
                }
            }
        }
        closedir($dir);
}
private function past()
{
		$dst=fw_strip_slashes(rawurldecode($_GET['dst']));
		$dst=substr($dst,0,-1);
		$clipboard=$_COOKIE['fw_clipboard'];
		if((strpos($clipboard,$this->template_path)!==0)||(empty($clipboard))){fw_message(true,'Source not found!');setcookie('fw_clipboard','');exit;}
		$x=(substr($clipboard,-1)=='/');
		if($x){
			$clipboard=substr($clipboard,0,-1);
			if(strpos($dst,$clipboard)===0){fw_message(true,'Unable to past parent folder under child.');exit;}
		}
		if(!file_exists($clipboard)){fw_message(true,'Source not found!');setcookie('fw_clipboard','');exit;}
		if(isset($_GET['name'])){
			$name=$_GET['name'];
			if((!preg_match('/[a-z0-9]/i',$name))||(!preg_match('/^([a-z0-9_\-\.]){1,50}$/i',$name))){fw_message(true,'Invalid file or folder name!');exit;}
			$dst.='/'.$name;
		}
		else{$dst.='/'.substr($clipboard,1+strrpos($clipboard,'/'));}
		if(file_exists($dst)){echo '<script>parent.fwPastNew();</script>';exit;}
		if($x){$this->recurse_copy($clipboard,$dst);echo '<script>parent.location.reload(true);</script>';}
		else{
			if(copy($clipboard,$dst)){echo '<script>parent.location.reload(true);</script>';}
			else{fw_message(true,'Sorry! Unable to copy. Please check file permission');}
		}
		setcookie('fw_clipboard','');
		exit;
}
private function rename_file()
{
        $source=fw_strip_slashes(rawurldecode($_GET['source']));
        $dst=fw_strip_slashes(rawurldecode($_GET['dst']));
		$x=(substr($source,-1)=='/');
		if($x){$source=substr($source,0,-1);}
		$path=substr($source,0,1+strrpos($source,'/'));
		$path=substr($path,0,-1);
		if((!preg_match('/[a-z0-9]/i',$dst))||(!preg_match('/^([a-z0-9_\-\.]){1,50}$/i',$dst))){fw_message(true,'Invalid file or folder name!');exit;}
		$dst=$path.'/'.$dst;
		if(file_exists($dst)){fw_message(true,'File / folder already exists!');exit;}
		if(!file_exists($source)){fw_message(true,'Source not found!');exit;}
		if(rename($source,$dst)){echo '<script>parent.location.reload(true);</script>';}
		else{fw_message(true,'Sorry! Unable to rename. Please check file permission.');}
		exit;
}

private function new_folder()
{
        $name=fw_strip_slashes(rawurldecode($_GET['name']));
		$path=fw_strip_slashes(rawurldecode($_GET['path']));
		if((!preg_match('/[a-z0-9]/i',$name))||(!preg_match('/^([a-z0-9_\-\.]){1,50}$/i',$name))){fw_message(true,'Invalid file or folder name!');exit;}
		$name=$path.$name;
		if(is_dir($name)){fw_message(true,'Sorry! Folder already exist. Please select different folder name.');exit;}
		if(mkdir($name)){echo '<script>parent.location.reload(true);</script>';}
		else{fw_message(true,'Sorry! Unable to create folder. Please check file permission.');}
		exit;
}

private function show_edit()
{
        $filename=fw_strip_slashes(rawurldecode($_GET['filename']));
        $str='<html><head><title>'.$filename.'</title><script type="text/javascript" src="../script/common.js"></script><script type="text/javascript" src="script/template.js"></script><script type="text/javascript">var pathindex='.$this->pathindex.';</script>';
		$str.='<style>
        <!--
        body, textarea{font-family:\'courier new\'; font-size:13px;line-height:140%;color:#333360;}
        body{height:100%;}
        a{ color:#0000ff;text-decoration:underline;font:500 12px tahoma;}
        a:hover{text-decoration:none;}
        -->
        </style></head>
        <body>
        <form name="frmEdit" style="margin:0; background:#dddddd; padding:0; min-width:600px; border:1px solid #cccccc; height:97%;" onSubmit="return(false);">
        <div style="background:#eeeeee url(\'images/bg.png\') repeat-x; padding:10px; clear:both; height:20px;">
        <div style="float:left; margin-bottom:10px;">
        <a href="javascript:fwSaveDocument(\''.fw_php2javascript($filename).'\');">Save</a> | <a href="javascript:window.close();">Close</a></div>
        <div id="feedback" style="float:right; clear:right;"></div>
        </div>
        <textarea style="width:100%; height:93%; border:none; padding:5px;" name="txtEdit" cols="20" rows="1" onClick="javascript:fwClearFeedback();">';
        $str.=htmlspecialchars(@file_get_contents($filename),ENT_QUOTES).'</textarea></form></body></html>';
        echo $str;
}

private function save_edit()
{
        $filename=trim(fw_strip_slashes(rawurldecode($_POST["filename"])));
        $content=trim(fw_strip_slashes(rawurldecode($_POST["content"])));
        if((strpos($filename,$this->template_path)===0)&&(file_exists($filename))){
                 if(@file_put_contents($filename,$content)===false){echo '<img src="images/close.gif" style="border:none;" /><span style="font-weight:600; color:red; margin-bottom:2px;">Unable to save file. Please check file permission.</span>';}
                 else{echo '<img src="images/right.gif" style="border:none;" /><span style="font-weight:600; color:green; margin-bottom:2px;">File has been updated.</span>';}
        }
}

public function get_query($query='')
{
if ($this->validate_user()){
    switch ($query[1]) {
        case "1":
            $this->show_uploadlist($this->upload_file($this->dir));
        break;
        case "2":
            $this->delete_file();
        break;
        case "3":
            $this->show_edit();
        break;
        case "4":
            $this->save_edit();
        break;
        case "5":
            $this->log_out();
        break;
        case "6":
            $this->extract();
        break;
        case "7":
            $this->rename_file();
        break;
        case "8":
            $this->past();
        break;
        case "9":
            $this->set_clipboard();
        break;
        case "10":
            $this->new_folder();
        break;
        case "11":
            $this->compress();
        break;
        default :
            $this->show_uploadlist();
    }
}
else {if($query[1]!='4'){$this->log_in();}}
}
private function upload_file($path)
{
        if(!(isset($_POST['submit']))){exit;}
        if($_FILES["file"]["size"] > 200000){exit;}
        $err=$_FILES["file"]["error"];
        $message='Upload fails! ';
        if ($err > 0){
               switch($err){
                     case '1':
                           $message.='php.ini max file size exceeded.';
                           break;
                     case '2':
                           $message.='max file size exceeded.';
                           break;
                     case '3':
                           $message.='file upload was only partial.';
                           break;
                     case '4':
                           $message.='no file was attached.';
                           break;
                     case '7':
                           $message.='file permission denied.';
                           break;
                     default :
                           $message.='Unexpected error occers.';}
        }
        else{
               if(file_exists($path.$_FILES["file"]["name"])){$message.='file already exist.';}
               else{$message=(@move_uploaded_file($_FILES["file"]["tmp_name"],$path. $_FILES["file"]["name"])? '':'Unexpected error occers.');}
        }
		if(!empty($message)){fw_message(true,$message);}
		else{echo '<script>parent.location.reload(true);</script>';}
		exit;
}
}
?>